Create endpoint
curl --request POST \
--url https://storage.nks.europe-west4.nscale.com/api/v1/objectstorageendpoints \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"metadata": {
"name": "my-s3-endpoint",
"description": "A verbose description",
"tags": [
{
"name": "tag-name",
"value": "tag-value"
}
]
},
"spec": {
"organizationId": "9a8c6370-4065-4d4a-9da0-7678df40cd9d",
"projectId": "e36c058a-8eba-4f5b-91f4-f6ffb983795c",
"regionId": "ba39bff5-b0d8-4c60-89e5-ed1104356b4a",
"objectStorageEndpointClassId": "7b6f8b33-3ca8-4db2-b7ab-7bbf683efc6d",
"identityPolicies": [
{
"name": "bucket-admin",
"document": {
"Version": "2012-10-17",
"Statement": [
{
"Effect": "Allow",
"Action": [
"s3:ListBucket",
"s3:GetObject"
],
"Resource": [
"arn:aws:s3:::example-bucket",
"arn:aws:s3:::example-bucket/*"
]
}
]
}
}
]
}
}
'import requests
url = "https://storage.nks.europe-west4.nscale.com/api/v1/objectstorageendpoints"
payload = {
"metadata": {
"name": "my-s3-endpoint",
"description": "A verbose description",
"tags": [
{
"name": "tag-name",
"value": "tag-value"
}
]
},
"spec": {
"organizationId": "9a8c6370-4065-4d4a-9da0-7678df40cd9d",
"projectId": "e36c058a-8eba-4f5b-91f4-f6ffb983795c",
"regionId": "ba39bff5-b0d8-4c60-89e5-ed1104356b4a",
"objectStorageEndpointClassId": "7b6f8b33-3ca8-4db2-b7ab-7bbf683efc6d",
"identityPolicies": [
{
"name": "bucket-admin",
"document": {
"Version": "2012-10-17",
"Statement": [
{
"Effect": "Allow",
"Action": ["s3:ListBucket", "s3:GetObject"],
"Resource": ["arn:aws:s3:::example-bucket", "arn:aws:s3:::example-bucket/*"]
}
]
}
}
]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
metadata: {
name: 'my-s3-endpoint',
description: 'A verbose description',
tags: [{name: 'tag-name', value: 'tag-value'}]
},
spec: {
organizationId: '9a8c6370-4065-4d4a-9da0-7678df40cd9d',
projectId: 'e36c058a-8eba-4f5b-91f4-f6ffb983795c',
regionId: 'ba39bff5-b0d8-4c60-89e5-ed1104356b4a',
objectStorageEndpointClassId: '7b6f8b33-3ca8-4db2-b7ab-7bbf683efc6d',
identityPolicies: [
{
name: 'bucket-admin',
document: {
Version: '2012-10-17',
Statement: [
{
Effect: 'Allow',
Action: ['s3:ListBucket', 's3:GetObject'],
Resource: ['arn:aws:s3:::example-bucket', 'arn:aws:s3:::example-bucket/*']
}
]
}
}
]
}
})
};
fetch('https://storage.nks.europe-west4.nscale.com/api/v1/objectstorageendpoints', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"metadata": {
"id": "a64f9269-36e0-4312-b8d1-52d93d569b7b",
"name": "my-s3-endpoint",
"organizationId": "9a8c6370-4065-4d4a-9da0-7678df40cd9d",
"projectId": "e36c058a-8eba-4f5b-91f4-f6ffb983795c",
"creationTime": "2024-05-31T14:11:00Z",
"createdBy": "john.doe@acme.com",
"provisioningStatus": "provisioned",
"healthStatus": "healthy",
"tags": [
{
"name": "tag-name",
"value": "tag-value"
}
]
},
"spec": {
"objectStorageEndpointClassId": "7b6f8b33-3ca8-4db2-b7ab-7bbf683efc6d",
"identityPolicies": [
{
"name": "bucket-admin",
"document": {
"Version": "2012-10-17",
"Statement": [
{
"Effect": "Allow",
"Action": [
"s3:ListBucket",
"s3:GetObject"
],
"Resource": [
"arn:aws:s3:::example-bucket",
"arn:aws:s3:::example-bucket/*"
]
}
]
}
}
]
},
"status": {
"regionId": "ba39bff5-b0d8-4c60-89e5-ed1104356b4a",
"exposure": {
"public": {
"dnsName": "s3.example.com"
}
}
}
}{
"error": "invalid_request",
"error_description": "request body invalid",
"trace_id": "57bc14d9bd461f0b5a72db830149b67a"
}{
"error": "access_denied",
"error_description": "authentication failed",
"trace_id": "57bc14d9bd461f0b5a72db830149b67a"
}{
"error": "forbidden",
"error_description": "user credentials do not have the required privileges",
"trace_id": "57bc14d9bd461f0b5a72db830149b67a"
}{
"error": "unprocessable_content",
"error_description": "the request body was in the wrong format",
"trace_id": "57bc14d9bd461f0b5a72db830149b67a"
}{
"error": "server_error",
"error_description": "failed to token claim",
"trace_id": "57bc14d9bd461f0b5a72db830149b67a"
}Object storage
Create endpoint
Provisions a new S3-compatible object storage endpoint in the requested organization, project, and region using the selected immutable endpoint class. Access keys are managed through dedicated APIs, and identity policies are managed as part of the endpoint specification.
POST
/
api
/
v1
/
objectstorageendpoints
Create endpoint
Authorizations
Operation requires OAuth 2.0 bearer token authentication.
Body
application/json
A request to create an object storage endpoint.
Response
An object storage endpoint.
An S3-compatible object storage endpoint that allows users to self-service create buckets through the access it exposes.
Was this page helpful?
⌘I